/* Generate sine/cosine lookup table
 * Jan 2002, Phil Karn, KA9Q
 * Copyright 2002, Phil Karn. This software may be used under the terms
 * of the GNU Public License (GPL).
 */
#include <math.h>
#include <stdlib.h>
#include <assert.h>
#include "dspfec.h"
short int Sintab[256];

void init_sin(void){
  int i;

  /* Create sine lookup table */
  for(i=0;i<256;i++){
    Sintab[i] = 32767.0 * sin(M_PI*(i/128.));
  }
}
