/* Internal definitions for dotproduct function */
struct dotprod_sse2 {
  int len; /* Number of coefficients */

  /* On a SSE2 machine, these hold 8 copies of the coefficients,
   * preshifted by 0,1,...7 words to meet all possible input data
   * alignments (see Intel ap559 on MMX dot products).
   *
   */
  v8hi *coeffs[8];
};
