/* Verify correctness of low level subroutines
 * $Id$
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include "dspfec.h"

int main(){
  int x,pc,pa,trial,parity_count,pop_count,i;
  unsigned int x1;

  /* Test parity function */
  for(trial=0;trial < 10000000;trial++){
    x1 = x = random();
        pc = popcnt(x);
        pa = parity(x);
	//pc = __builtin_popcount(x);
	//pa = __builtin_parity(x);

    parity_count = pop_count = 0;
    for(i=0; x1 !=0 && i<32; i++){
      parity_count ^= x1 & 1;
      pop_count += x1 & 1;
      x1 >>= 1;
    }
    if(parity_count != pa){
      printf("Trial %d: parity error on 0x%x: 0x%x vs %d\n",trial,x,pa,parity_count);
      exit(1);
    }
    if(pop_count != pc){
      printf("Trial %d: popcnt error on 0x%x: %d vs %d\n",trial,x,pc,pop_count);
      exit(1);
    }
  }
  exit(0);
}
